package fr.inra.pappso.sax_parse;

import org.xml.sax.*;
import fr.inra.pappso.class_pep.Ms_run;
import fr.inra.pappso.class_pep.Spectre;
import fr.inra.pappso.class_pep.seq_prot;
import fr.inra.pappso.pep_exception.PepException;

public class xtandem_parse extends org.xml.sax.helpers.DefaultHandler {
	private Spectre spectre_;

	private Ms_run msrun_;

	private String Last_element_;

	private String Start_element_;

	private String C_data;

	private int _scan;

	private String _type;

	private boolean prot_sequence;

	private boolean prot_description;

	private seq_prot prot_;

	public xtandem_parse() {
		super();
	}

	public xtandem_parse(Ms_run msrun) {
		super();
		msrun_ = msrun;
	}

	public void set_msrun(Ms_run msrun) {
		msrun_ = msrun;
	}

	// Les methodes qui suivent sont appelées
	// automatiquement par l'analyseur
	// lorsqu'un événement est détecté
	// dans le fichier XML.
	public void error(SAXParseException e) throws SAXParseException {
		throw (e);
	}

	public void startDocument() throws SAXException {
		Last_element_ = "";
		Start_element_ = "";
		C_data = "";
		_scan = 0;
		_type = "";
		prot_sequence = false;
		prot_description = false;
		prot_ = new seq_prot();

		// identification_.add_sample(sample_.getName());
	}

	public void endDocument() throws SAXException {
		// System.out.println("fin du document");
	}

	public void startElement(String namespaceURI, String simpleName,
			String qualifiedName, Attributes attrs) throws SAXException {

		Start_element_ = simpleName;
		if (Start_element_.equals(""))
			Start_element_ = qualifiedName;

		if (Start_element_.equals("group")) {
			_type = attrs.getValue("type");
			if (_type.equals("model")) {
				_scan = Integer.parseInt(attrs.getValue("id"));
				try {
					spectre_ = msrun_.get_spectra_to_scan("" + _scan);
				} catch (PepException e) {
					throw new SAXException(e);
				}
				spectre_.set_Identified(true);
			}
		}

		if (Start_element_.equals("protein")) {
			prot_description = true;
		}

		if (prot_sequence) {
			prot_.set_sequence(C_data);
			prot_sequence = false;
		}

		if (Start_element_.equals("peptide"))
			prot_sequence = true;

		C_data = "";
	}

	public void endElement(String namespaceURI, String simpleName,
			String qualifiedName) throws SAXException {
		Last_element_ = simpleName;
		if (Last_element_.equals(""))
			Last_element_ = qualifiedName;

		if (Last_element_.equals("note")) {
			if (prot_description) {
				prot_.set_description(C_data);
				prot_description = false;
			}
		}

		if (Last_element_.equals("protein")) {
			if (!msrun_.is_protein_exist(prot_))
				msrun_.add_xtandem_prot(prot_);
			prot_ = new seq_prot();
		}

		C_data = "";
	}

	public void characters(char buf[], int offset, int len) throws SAXException {
		C_data = C_data + new String(buf, offset, len);
		// System.out.println(C_data);
	}

}
