package fr.inra.pappso.shell;

import java.io.*;

import org.apache.log4j.Logger;

import fr.inra.pappso.pep_exception.PepException;

public class base_shell {
	private static final Logger logger = Logger.getLogger(base_shell.class);

	private ProcessBuilder build;

	private String application;

	private String[] commande;

	private String stdout;

	private String error;

	private Process process_run;

	private monthread t;

	public base_shell() {
		application = "";
		stdout = "";
		error = "";
	}

	public void set_commande(String[] commande) {
		this.commande = commande;
		application = commande[0];
		
		logger.debug(application);
	}

	public String[] get_commande() {
		return commande;
	}

	public String get_Stdout() {
		return stdout;
	}

	public void start_process() throws Exception {
		if (application.equals(""))
			throw new PepException("No application specified");
		build = new ProcessBuilder(commande);
		build.redirectErrorStream(true);
		process_run = build.start();
		t = new monthread();
		t.setDaemon(true);
		t.start();
	}

	public void processing(String mess) {
		// analyse du flux de sortie de l'application
		logger.debug(mess);
	}

	public String get_error() {
		// gérer les erreurs
		return (error);
	}

	protected void set_error(String err) {
		// gérer les erreurs
		this.error += err + "\n";
	}

	synchronized public boolean status() {
		return (t.isAlive());
	}

	synchronized public void stop_process() {
		// Arret de l'application
		process_run.destroy();
	}

	public void test_result() {

	}

	class monthread extends Thread {
		public void run() {
			try {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(process_run.getInputStream()));
				String line = "";
				try {
					while ((line = reader.readLine()) != null) {
						processing(line);
						stdout += line + System.getProperty("line.separator");
						// System.out.println(line);
					}
				} finally {
					reader.close();
					test_result();
				}
			} catch (IOException ioe) {
				set_error("" + ioe);
			}
		}
	}

}
