package fr.inra.pappso.shell;

import java.util.regex.*;

import org.apache.log4j.Logger;

import fr.inra.pappso.class_pep.Ms_run;
import fr.inra.pappso.class_pep.Pep_result;
import fr.inra.pappso.pep_exception.PepException;

public class pepnovo_calculation extends base_shell {
	private static final Logger logger = Logger
			.getLogger(pepnovo_calculation.class);

	private Pattern regex_scan;

	private Pattern regex_result;

	private Pattern result_ok;

	private Ms_run run;

	private boolean is_scored;

	private boolean contained_RnkScr;

	private Pep_result result;

	private float seuil;

	private int count;

	public pepnovo_calculation() {
		super();
		regex_result = Pattern.compile("^0\\t*");
		// regex_scan = Pattern.compile("^\\>\\>\\.mzXML_(\\d+) *");
		regex_scan = Pattern.compile("^\\>\\>*");
		result_ok = Pattern.compile("^\\#Index*");
		result = new Pep_result();
		count = 0;
		is_scored = false;
		contained_RnkScr = false;
	}

	public void processing(String mess) {
		try {
			logger.debug(mess);
			Matcher resultat_scan = regex_scan.matcher(mess);
			if (resultat_scan.find()) {
				// String[] scans = mess.split(".mzXML_");
				String[] scans = mess.split(" ");
				// System.out.print("\n");
				// System.out.print(scans[1] + " ");
				// test si il s'agit bien d'un scan
				run.get_spectra_to_scan(scans[2]);
				result.set_Scan(scans[2]);
				is_scored = false;
				contained_RnkScr = false;
				count++;
			}

			Matcher resultat_ok = result_ok.matcher(mess);
			if (resultat_ok.find()) {
				is_scored = true;
				String[] table = mess.split("\t");
				if (table[2].equals("PnvScr"))
					contained_RnkScr = true;
			}

			Matcher resultat_score = regex_result.matcher(mess);
			if (resultat_score.find()) {
				if (!is_scored)
					this.set_error("There is no result score for " + mess);
				String[] score = mess.split("\t");
				int i = 0;
				if (contained_RnkScr) {
					i++;
					result.se_tRnkScr(Float.valueOf(score[1]).floatValue());
				}
				result.set_PnvScr(Float.valueOf(score[i + 1]).floatValue());
				result.set_N_Gap(Float.valueOf(score[i + 2]).floatValue());
				result.set_C_Gap(Float.valueOf(score[i + 3]).floatValue());
				result.set_Mh_pepnovo(Float.valueOf(score[i + 4]).floatValue());
				result.set_Charge(Integer.parseInt(score[i + 5]));
				// score[i+6] = score[i+6].replaceAll("M+16", "m");
				result.set_Sequence(score[i + 6]);

				// System.out.print(score[i+1]+" ");
				// System.out.print(score[i+6]);
				run.add_Pepnovo_result(result);
				result = new Pep_result();

			}

		} catch (PepException e) {
			this.set_error("" + e);
		}
	}

	public void set_Msrun(Ms_run run) {
		this.run = run;
	}

	public void set_seuil_filter(float F) {
		this.seuil = F;
	}

	public void test_result() {
		if (count != run.get_spectra_valid_number(this.seuil))
			this.set_error("Error during pepnovo calculation analysis\n"
					+ this.get_Stdout());
	}

	synchronized public int get_count() {
		return (count);
	}
}
